

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Hypercall Calling Convention &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="Supported hypercalls" href="supported_hypercalls.html"/>
        <link rel="prev" title="Hypercall Interfaces - arm64" href="../arm64.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4 current"><a class="current reference internal" href="#">Hypercall Calling Convention</a></li>
<li class="toctree-l4"><a class="reference internal" href="supported_hypercalls.html">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4"><a class="reference internal" href="event_channels.html">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_shared_data_structure.html">Start-of-day shared data structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_memory_layout.html">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4"><a class="reference internal" href="elf_notes.html">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>Hypercall Calling Convention</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/hypercall_calling_convention.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="hypercall-calling-convention">
<h1>Hypercall Calling Convention<a class="headerlink" href="#hypercall-calling-convention" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__hypercall__calling__convention"></span><em>group</em> <code class="descname">hypercall_calling_convention</code></dt>
<dd><p>A hypercall is issued using the ARM HVC instruction. </p>
<p>A hypercall can take up to 5 arguments. These are passed in registers, the first argument in x0/r0 (for arm64/arm32 guests respectively irrespective of whether the underlying hypervisor is 32- or 64-bit), the second argument in x1/r1, the third in x2/r2, the forth in x3/r3 and the fifth in x4/r4.</p>
<p>The hypercall number is passed in r12 (arm) or x16 (arm64). In both cases the relevant ARM procedure calling convention specifies this is an inter-procedure-call scratch register (e.g. for use in linker stubs). This use does not conflict with use during a hypercall.</p>
<p>The HVC ISS must contain a Xen specific TAG: XEN_HYPERCALL_TAG.</p>
<p>The return value is in x0/r0.</p>
<p>The hypercall will clobber x16/r12 and the argument registers used by that hypercall (except r0 which is the return value) i.e. in addition to x16/r12 a 2 argument hypercall will clobber x1/r1 and a 4 argument hypercall will clobber x1/r1, x2/r2 and x3/r3.</p>
<p>Parameter structs passed to hypercalls are laid out according to the Procedure Call Standard for the ARM Architecture (AAPCS, AKA EABI) and Procedure Call Standard for the ARM 64-bit Architecture (AAPCS64). Where there is a conflict the 64-bit standard should be used regardless of guest type. Structures which are passed as hypercall arguments are always little endian.</p>
<p>All memory which is shared with other entities in the system (including the hypervisor and other guests) must reside in memory which is mapped as Normal Inner Write-Back Outer Write-Back Inner-Shareable. This applies to:<ul class="simple">
<li>hypercall arguments passed via a pointer to guest memory.</li>
<li>memory shared via the grant table mechanism (including PV I/O rings etc).</li>
<li>memory shared with the hypervisor (struct <a class="reference internal" href="start_of_day_shared_data_structure.html#structshared__info"><span class="std std-ref">shared_info</span></a>, struct vcpu_info, the grant table, etc).</li>
</ul>
</p>
<p>Any cache allocation hints are acceptable. </p>
</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="supported_hypercalls.html" class="btn btn-neutral float-right" title="Supported hypercalls" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../arm64.html" class="btn btn-neutral" title="Hypercall Interfaces - arm64" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>